/*
 * All or portions of this file Copyright (c) Amazon.com, Inc. or its affiliates or
 * its licensors.
 *
 * For complete copyright and license terms please see the LICENSE at the root of this
 * distribution (the "License"). All use of this software is governed by the License,
 * or, if provided, by the license below or the license accompanying this file. Do not
 * remove or modify any license notices. This file is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *
 */

#include <AzCore/Memory/SystemAllocator.h>
#include <AzCore/Module/Module.h>

#include <WelcomeGuideTutorialsSystemComponent.h>

namespace WelcomeGuideTutorials
{
    class WelcomeGuideTutorialsModule
        : public AZ::Module
    {
    public:
        AZ_RTTI(WelcomeGuideTutorialsModule, "{AEF34E1E-64A8-4CBA-90D5-DA799BB0BBBA}", AZ::Module);
        AZ_CLASS_ALLOCATOR(WelcomeGuideTutorialsModule, AZ::SystemAllocator, 0);

        WelcomeGuideTutorialsModule()
            : AZ::Module()
        {
            // Push results of [MyComponent]::CreateDescriptor() into m_descriptors here.
            m_descriptors.insert(m_descriptors.end(), {
                WelcomeGuideTutorialsSystemComponent::CreateDescriptor(),
            });
        }

        /**
         * Add required SystemComponents to the SystemEntity.
         */
        AZ::ComponentTypeList GetRequiredSystemComponents() const override
        {
            return AZ::ComponentTypeList {
                azrtti_typeid<WelcomeGuideTutorialsSystemComponent>(),
            };
        }
    };
}

// DO NOT MODIFY THIS LINE UNLESS YOU RENAME THE GEM
// The first parameter should be GemName_GemIdLower
// The second should be the fully qualified name of the class above
AZ_DECLARE_MODULE_CLASS(WelcomeGuideTutorials_a41acb3618aa4e98b8056c6297daead8, WelcomeGuideTutorials::WelcomeGuideTutorialsModule)
